﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public enum GameDifficulty
{
    LEVEL01,
    LEVEL02,
    LEVEL03
}

public class GameManager : MonoBehaviour
{

    float m_currentScore;
    float m_scoreNeededDisplay;

    float m_currentTime;
    float m_timeLimit;
    string m_timeDisplay;
    string m_currentLevelDisplay;

    public Text m_Score;
    public Text m_Time;
    public Text m_Level;
    public Text m_ScoreNeeded;

    public static GameManager Instance = null;
    void Awake()
    {
        SetInstance();
        SetupRulesForRound(GameDifficulty.LEVEL01);
    }

    void Update()
    {
        CountTime();
        m_timeDisplay = m_currentTime.ToString() + "/" + m_timeLimit.ToString();
        m_Score.text = "Score: " + m_currentScore.ToString();
        m_Time.text = "Time: " + m_timeDisplay.ToString();
        m_Level.text = m_currentLevelDisplay;
        m_ScoreNeeded.text = "Score Needed: " + m_scoreNeededDisplay.ToString();
    }

    void SetInstance()
    {
        if (Instance == null)
        {
            Instance = this;
        }
        else if (Instance != this)
        {
            Destroy(gameObject);
        }

        DontDestroyOnLoad(gameObject);
    }

    void SetupRulesForRound(GameDifficulty diffy)
    {
        switch (diffy)
        {
            case GameDifficulty.LEVEL01:
                m_currentLevelDisplay = "LEVEL 01";
                m_scoreNeededDisplay = 100;
                m_timeLimit = 60;

                break;
            case GameDifficulty.LEVEL02:
                m_currentLevelDisplay = "LEVEL 02";
                m_scoreNeededDisplay = 200;
                m_timeLimit = 45;

                break;
            case GameDifficulty.LEVEL03:
                m_currentLevelDisplay = "LEVEL 03";
                m_scoreNeededDisplay = 300;
                m_timeLimit = 30;

                break;
        }
    }

    void CountTime()
    {
        m_currentTime += m_currentTime * Time.deltaTime;
        
    }
}
