﻿using System.Collections;
using System.Collections.Generic;
using System.Threading;
using UnityEngine;


public enum PlatformState
{
    STAGEA,
    STAGEB
}

public class PlatformController : MonoBehaviour
{
    PlatformState m_state;

    Vector3 m_platformOGPosition;
    Vector3 m_stageAMovementVector;
    Vector3 m_stageBMovementVector;

    Rigidbody2D m_rigidbody;
    float m_horizontalMovement;
    float m_verticalMovement;

    public float m_moveSpeed;
    public float m_moveTimeElasped;
    public float m_x_direction = 1;
    float translation;

    float timer = 0;
    bool timerReached = false;

    static float m_DEFAULT_MOVE_SPEED = 0.5f;


    // Start is called before the first frame update
    void Start()
    {
        m_rigidbody = GetComponent<Rigidbody2D>();

        m_platformOGPosition = this.transform.position;

        m_stageAMovementVector = new Vector3((m_platformOGPosition.x + m_DEFAULT_MOVE_SPEED) * Time.deltaTime, 0, 0);

        m_stageBMovementVector = new Vector3(((m_platformOGPosition.x + m_DEFAULT_MOVE_SPEED) * Time.deltaTime) * -1, 0, 0);

        m_state = PlatformState.STAGEA;

    }

    // Update is called once per frame
    void Update()
    {
        
        if (!timerReached)
            timer += Time.deltaTime;
        else if (timerReached)
            timerReached = false;

        if (!timerReached && timer > 1)
        {
            Debug.Log("Done waiting");
            ChangeState();

            //Set to false so that We don't run this again
            timerReached = true;
            timer = 0;
        }
    }

    private void FixedUpdate()
    {
        switch (m_state)
        {
            case PlatformState.STAGEA:
                transform.Translate(m_stageAMovementVector);
                //delay

                break;

            case PlatformState.STAGEB:
                transform.Translate(m_stageBMovementVector);
                //delay

                break;
        }
    }

    void ChangeState()
    {
        switch (m_state)
        {
            case PlatformState.STAGEA:
                m_state = PlatformState.STAGEB;
                Debug.Log("Done A");
                break;
            case PlatformState.STAGEB:
                m_state = PlatformState.STAGEA;
                Debug.Log("Done B");
                break;
        }
    }
}
