﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;

public class Rope : MonoBehaviour
{
    public Rigidbody2D topRope;
    public GameObject[] prefabRopeSegments;
    public int links = 20;

    public HingeJoint2D top;

    // Start is called before the first frame update
    void Start()
    {
        GenerateRope();
    }

    void GenerateRope()
    {
        Rigidbody2D prevBody = topRope;
        for (int i = 0; i < links; i++)
        {
            if (i != (links - 1))
            {
                int index = UnityEngine.Random.Range(0, (prefabRopeSegments.Length - 1));
                GameObject newSegment = Instantiate(prefabRopeSegments[index]);
                newSegment.transform.parent = transform;
                newSegment.transform.position = transform.position;
                HingeJoint2D hinge = newSegment.GetComponent<HingeJoint2D>();
                hinge.connectedBody = prevBody;

                prevBody = newSegment.GetComponent<Rigidbody2D>();

                if (i == 0) 
                {
                    top = hinge;
                }
            }
            else 
            {
                int index = prefabRopeSegments.Length - 1;
                GameObject newSegment = Instantiate(prefabRopeSegments[index]);
                newSegment.transform.parent = transform;
                newSegment.transform.position = transform.position;
                HingeJoint2D hinge = newSegment.GetComponent<HingeJoint2D>();
                hinge.connectedBody = prevBody;

                prevBody = newSegment.GetComponent<Rigidbody2D>();
            }
        }
    }

    public void addLink()
    {
        int index = UnityEngine.Random.Range(0, (prefabRopeSegments.Length - 1));
        GameObject newLink = Instantiate(prefabRopeSegments[index]);
        newLink.transform.parent = transform;
        newLink.transform.position = transform.position;
        HingeJoint2D hinge = newLink.GetComponent<HingeJoint2D>();
        hinge.connectedBody = topRope;
        newLink.GetComponent<RopeSegment>().connectedBelow = top.gameObject;
        top.connectedBody = newLink.GetComponent<Rigidbody2D>();
        top.GetComponent<RopeSegment>().ResetAnchor();
        top = hinge;
    }

    public void removeLink()
    {
        HingeJoint2D newTop = top.gameObject.GetComponent<RopeSegment>().connectedBelow.GetComponent<HingeJoint2D>();
        newTop.connectedBody = topRope;
        newTop.gameObject.transform.position = topRope.gameObject.transform.position;
        newTop.GetComponent<RopeSegment>().ResetAnchor();
        Destroy(top.gameObject);
        top = newTop;
    }
}
