﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SpawnerScript : MonoBehaviour
{
    public GameObject[] SpawnPoints;

    public GameObject[] Objects;

    public BoxCollider2D m_spawnHigh;
    public BoxCollider2D m_spawnMid;
    public BoxCollider2D m_spawnLow;

    // Start is called before the first frame update
    void Start()
    {

    }

    // Update is called once per frame
    void Update()
    {
        
    }

    protected void SpawnObject(GameObject obj)
    {
        //make a copy of obj and instantiate it
        GameObject ChosenObj = obj;
        GameObject newObj = Instantiate(ChosenObj);

        string tagName = obj.tag;

        switch(tagName)
        {
            case "EnemyLV1":
                obj.transform.position = RandomVectorWithinCollider(m_spawnHigh.GetComponent<BoxCollider2D>());
                break;
            case "EnemyLV2":
                obj.transform.position = RandomVectorWithinCollider(m_spawnMid.GetComponent<BoxCollider2D>());
                break;
            case "EnemyLV3":
                obj.transform.position = RandomVectorWithinCollider(m_spawnLow.GetComponent<BoxCollider2D>());
                break;
            case "PickupLV1":
                obj.transform.position = RandomVectorWithinCollider(m_spawnHigh.GetComponent<BoxCollider2D>());
                break;
            case "PickupLV2":
                obj.transform.position = RandomVectorWithinCollider(m_spawnMid.GetComponent<BoxCollider2D>());
                break;
            case "PickupLV3":
                obj.transform.position = RandomVectorWithinCollider(m_spawnLow.GetComponent<BoxCollider2D>());
                break;
            case "PlatformLV1":
                obj.transform.position = RandomVectorWithinCollider(m_spawnHigh.GetComponent<BoxCollider2D>());
                break;
            case "PlatformLV2":
                obj.transform.position = RandomVectorWithinCollider(m_spawnMid.GetComponent<BoxCollider2D>());
                break;
            case "PlatformLV3":
                obj.transform.position = RandomVectorWithinCollider(m_spawnLow.GetComponent<BoxCollider2D>());
                break;

        }
    }

    protected void DeleteObject(GameObject obj)
    {
        Destroy(obj);
    }

    Vector3 RandomVectorWithinCollider(BoxCollider2D colli)
    {
        return new Vector3(Random.Range(colli.bounds.min.x, colli.bounds.max.x), Random.Range(colli.bounds.min.y, colli.bounds.max.y), 0);
    }
}
